diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/ProcessCertReq.java b/pki/base/common/src/com/netscape/cms/servlet/request/ProcessCertReq.java
index 6e782f5ab147607009fe2c6c43760bc4a6b786cf..063528367a88e8d9835833b804655829e5de0786 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/ProcessCertReq.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/ProcessCertReq.java
@@ -1439,45 +1438,45 @@ public class ProcessCertReq extends CMSServlet {
                 if (toDo.equals(SIGNED_AUDIT_CLONING)) {
                     // ("agent" cert request for "cloning")
                     auditMessage = CMS.getLogMessage(
-                                LOGGING_SIGNED_AUDIT_NON_PROFILE_CERT_REQUEST,
-                                auditSubjectID,
-                                ILogger.FAILURE,
-                                auditRequesterID,
-                                auditServiceID,
-                                auditCertificateSubjectName);
+                            LOGGING_SIGNED_AUDIT_NON_PROFILE_CERT_REQUEST,
+                            auditSubjectID,
+                            ILogger.FAILURE,
+                            auditRequesterID,
+                            auditServiceID,
+                            auditCertificateSubjectName);
 
                     audit(auditMessage);
                 } else if (toDo.equals(SIGNED_AUDIT_ACCEPTANCE)) {
                     // (manual "agent" cert request processed - "accepted")
                     auditMessage = CMS.getLogMessage(
-                                LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED,
-                                auditSubjectID,
-                                ILogger.FAILURE,
-                                auditRequesterID,
-                                auditInfoName,
-                                ILogger.SIGNED_AUDIT_EMPTY_VALUE);
+                            LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED,
+                            auditSubjectID,
+                            ILogger.FAILURE,
+                            auditRequesterID,
+                            auditInfoName,
+                            ILogger.SIGNED_AUDIT_EMPTY_VALUE);
 
                     audit(auditMessage);
                 } else if (toDo.equals(SIGNED_AUDIT_CANCELLATION)) {
                     // (manual "agent" cert request processed - "cancelled")
                     auditMessage = CMS.getLogMessage(
-                                LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED,
-                                auditSubjectID,
-                                ILogger.FAILURE,
-                                auditRequesterID,
-                                auditInfoName,
-                                SIGNED_AUDIT_MANUAL_CANCELLATION_REASON[5]);
+                            LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED,
+                            auditSubjectID,
+                            ILogger.FAILURE,
+                            auditRequesterID,
+                            auditInfoName,
+                            SIGNED_AUDIT_MANUAL_CANCELLATION_REASON[5]);
 
                     audit(auditMessage);
                 } else if (toDo.equals(SIGNED_AUDIT_REJECTION)) {
                     // (manual "agent" cert request processed - "rejected")
                     auditMessage = CMS.getLogMessage(
-                                LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED,
-                                auditSubjectID,
-                                ILogger.FAILURE,
-                                auditRequesterID,
-                                auditInfoName,
-                                SIGNED_AUDIT_MANUAL_REJECTION_REASON[5]);
+                            LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED,
+                            auditSubjectID,
+                            ILogger.FAILURE,
+                            auditRequesterID,
+                            auditInfoName,
+                            SIGNED_AUDIT_MANUAL_REJECTION_REASON[5]);
 
                     audit(auditMessage);
                 }
@@ -1642,7 +1641,7 @@ public class ProcessCertReq extends CMSServlet {
 
             try {
                 authzToken = authorize(mAclMethod, authToken,
-                            resourceName, "add");
+                        resourceName, "add");
             } catch (Exception e) {
                 // do nothing for now
             }
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/ProcessReq.java b/pki/base/common/src/com/netscape/cms/servlet/request/ProcessReq.java
index 78f047d2cd45c027680f0e482a40d99a98f240b9..d33250b5df67e57a4ca3ea1f01230fd068d854c6 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/ProcessReq.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/ProcessReq.java
@@ -19,6 +19,7 @@ package com.netscape.cms.servlet.request;
 
 import java.io.IOException;
 import java.util.Locale;
+import java.math.BigInteger;
 
 import javax.servlet.ServletConfig;
 import javax.servlet.ServletException;
@@ -73,7 +74,7 @@ public class ProcessReq extends CMSServlet {
     private String[] mSigningAlgorithms = null;
 
     private static String[] DEF_SIGNING_ALGORITHMS = new String[]
-        { "SHA1withRSA", "SHA256withRSA", "SHA512withRSA", "SHA1withDSA", "MD5withRSA", "MD2withRSA" };
+    { "SHA1withRSA", "SHA256withRSA", "SHA512withRSA", "SHA1withDSA", "MD5withRSA", "MD2withRSA" };
 
     /**
      * Process request.
@@ -130,7 +131,7 @@ public class ProcessReq extends CMSServlet {
      * @param cmsReq the object holding the request and response information
      */
     public void process(CMSRequest cmsReq) throws EBaseException {
-        int seqNum = -1;
+        BigInteger seqNum = BigInteger.ONE.negate();
 
         HttpServletRequest req = cmsReq.getHttpReq();
         HttpServletResponse resp = cmsReq.getHttpResp();
@@ -158,25 +159,25 @@ public class ProcessReq extends CMSServlet {
 
         try {
             if (req.getParameter(SEQNUM) != null) {
-                seqNum = Integer.parseInt(req.getParameter(SEQNUM));
+                seqNum = new BigInteger(req.getParameter(SEQNUM));
             }
             doAssign = req.getParameter(DO_ASSIGN);
 
-            if (seqNum > -1) {
+            if (seqNum.compareTo(BigInteger.ONE.negate()) > 0) {
                 // start authorization
                 AuthzToken authzToken = null;
 
                 try {
                     if (doAssign == null) {
                         authzToken = authorize(mAclMethod, authToken,
-                                    mAuthzResourceName, "read");
+                                mAuthzResourceName, "read");
                     } else if (doAssign.equals("toMe") ||
                             doAssign.equals("reassignToMe")) {
                         authzToken = authorize(mAclMethod, authToken,
-                                    mAuthzResourceName, "assign");
+                                mAuthzResourceName, "assign");
                     } else if (doAssign.equals("reassignToNobody")) {
                         authzToken = authorize(mAclMethod, authToken,
-                                    mAuthzResourceName, "unassign");
+                                mAuthzResourceName, "unassign");
                     }
                 } catch (EAuthzAccessDenied e) {
                     log(ILogger.LL_FAILURE,
@@ -237,15 +238,14 @@ public class ProcessReq extends CMSServlet {
      * returns whether there was an error or not.
      */
     private void process(CMSTemplateParams argSet, IArgBlock header,
-            int seqNum, HttpServletRequest req,
+            BigInteger seqNum, HttpServletRequest req,
             HttpServletResponse resp,
             String doAssign, Locale locale)
             throws EBaseException {
 
-        header.addIntegerValue("seqNum", seqNum);
+        header.addBigIntegerValue("seqNum", seqNum, 10);
 
-        IRequest r =
-                mQueue.findRequest(new RequestId(Integer.toString(seqNum)));
+        IRequest r = mQueue.findRequest(new RequestId(seqNum.toString()));
 
         if (r != null) {
             if (doAssign != null) {
@@ -280,7 +280,7 @@ public class ProcessReq extends CMSServlet {
 
                 if (allAlgorithms == null) {
                     allAlgorithms = mSigningAlgorithms =
-                                    ((ICertAuthority) mAuthority).getCASigningAlgorithms();
+                            ((ICertAuthority) mAuthority).getCASigningAlgorithms();
                     if (allAlgorithms == null) {
                         CMS.debug(
                                 "ProcessReq: signing algorithms set to All algorithms");
@@ -324,10 +324,10 @@ public class ProcessReq extends CMSServlet {
 
             mParser.fillRequestIntoArg(locale, r, argSet, header);
         } else {
-            log(ILogger.LL_FAILURE, "Invalid sequence number " + seqNum);
+            log(ILogger.LL_FAILURE, "Invalid sequence number " + seqNum.toString());
             throw new ECMSGWException(
                     CMS.getUserMessage("CMS_GW_INVALID_REQUEST_ID",
-                            String.valueOf(seqNum)));
+                            seqNum.toString()));
         }
 
         return;
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/QueryReq.java b/pki/base/common/src/com/netscape/cms/servlet/request/QueryReq.java
index 3cb2704666b11967815c9de748ba9ea4ddddd498..8ec82d0a42c0faa19ef551b4a9b172c57a4db6e8 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/QueryReq.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/QueryReq.java
@@ -21,6 +21,7 @@ import java.io.IOException;
 import java.util.Enumeration;
 import java.util.Locale;
 import java.util.Vector;
+import java.math.BigInteger;
 
 import javax.servlet.ServletConfig;
 import javax.servlet.ServletException;
@@ -291,7 +292,8 @@ public class QueryReq extends CMSServlet {
             direction = req.getParameter("direction").trim();
         }
 
-        int top = 0, bottom = 0;
+        BigInteger top = BigInteger.ZERO;
+        BigInteger bottom = BigInteger.ZERO;
 
         try {
             String top_s = req.getParameter(OUT_FIRST_ENTRY_ON_PAGE);
@@ -303,14 +305,14 @@ public class QueryReq extends CMSServlet {
                 bottom_s = "0";
 
             if (top_s.trim().startsWith("0x")) {
-                top = Integer.parseInt(top_s.trim().substring(2), 16);
+                top = new BigInteger(top_s.trim().substring(2), 16);
             } else {
-                top = Integer.parseInt(top_s.trim());
+                top = new BigInteger(top_s.trim());
             }
             if (bottom_s.trim().startsWith("0x")) {
-                bottom = Integer.parseInt(bottom_s.trim().substring(2), 16);
+                bottom = new BigInteger(bottom_s.trim().substring(2), 16);
             } else {
-                bottom = Integer.parseInt(bottom_s.trim());
+                bottom = new BigInteger(bottom_s.trim());
             }
 
         } catch (NumberFormatException e) {
@@ -362,18 +364,19 @@ public class QueryReq extends CMSServlet {
      */
 
     private CMSTemplateParams doSearch(Locale l, String filter,
-            int count, String direction, int top, int bottom) {
+            int count, String direction, BigInteger top, BigInteger bottom) {
         CMSTemplateParams ctp = null;
         if (direction.equals("previous")) {
-            ctp = doSearch(l, filter, -count, top - 1);
+            ctp = doSearch(l, filter, -count, top);
         } else if (direction.equals("next")) {
-            ctp = doSearch(l, filter, count, bottom + 1);
+            bottom = bottom.add(BigInteger.ONE);
+            ctp = doSearch(l, filter, count, bottom);
         } else if (direction.equals("begin")) {
-            ctp = doSearch(l, filter, count, 0);
+            ctp = doSearch(l, filter, count, BigInteger.ZERO);
         } else if (direction.equals("first")) {
             ctp = doSearch(l, filter, count, bottom);
         } else { // if 'direction is 'end', default here
-            ctp = doSearch(l, filter, -count, -1);
+            ctp = doSearch(l, filter, -count, BigInteger.ONE.negate());
         }
         return ctp;
     }
@@ -391,7 +394,7 @@ public class QueryReq extends CMSServlet {
             Locale locale,
             String filter,
             int count,
-            int marker) {
+            BigInteger marker) {
 
         IArgBlock header = CMS.createArgBlock();
         IArgBlock context = CMS.createArgBlock();
@@ -406,32 +409,41 @@ public class QueryReq extends CMSServlet {
             header.addStringValue(OUT_REQUESTING_USER, "admin");
 
             boolean jumptoend = false;
-            if (marker == -1) {
-                marker = 0; // I think this is inconsequential
+            if (marker.toString().equals("-1")) {
+                marker = BigInteger.ZERO; // I think this is inconsequential
                 jumptoend = true; // override  to '99' during search 
             }
 
-            RequestId id = new RequestId(Integer.toString(marker));
+            RequestId id = new RequestId(marker.toString());
             IRequestVirtualList list = mQueue.getPagedRequestsByFilter(
                     id,
                     jumptoend,
                     filter,
-                    count + 1,
+                    ((count < 0) ? count - 1 : count + 1),
                     "requestId");
 
-            int totalCount = list.getSize() - list.getCurrentIndex();
+            int maxCount = 0;
+            if (count < 0 && jumptoend) {
+                maxCount = -count;
+            } else if (count < 0) {
+                maxCount = -count + 1;
+            } else {
+                maxCount = count;
+            }
+            int totalCount = (jumptoend) ? maxCount :
+                    (list.getSize() - list.getCurrentIndex());
             header.addIntegerValue(OUT_TOTALCOUNT, totalCount);
             header.addIntegerValue(OUT_CURRENTCOUNT, list.getSize());
 
             int numEntries = list.getSize() - list.getCurrentIndex();
 
-            Vector v = fetchRecords(list, Math.abs(count));
+            Vector v = fetchRecords(list, maxCount);
             v = normalizeOrder(v);
             trim(v, id);
 
             int currentCount = 0;
-            int curNum = 0;
-            int firstNum = -1;
+            BigInteger curNum = BigInteger.ZERO;
+            BigInteger firstNum = BigInteger.ONE.negate();
             Enumeration requests = v.elements();
 
             while (requests.hasMoreElements()) {
@@ -447,10 +459,9 @@ public class QueryReq extends CMSServlet {
                     continue;
                 }
 
-                curNum = Integer.parseInt(
-                        request.getRequestId().toString());
+                curNum = new BigInteger(request.getRequestId().toString());
 
-                if (firstNum == -1) {
+                if (firstNum.equals(BigInteger.ONE.negate())) {
                     firstNum = curNum;
                 }
 
@@ -466,15 +477,14 @@ public class QueryReq extends CMSServlet {
 
             header.addIntegerValue(OUT_CURRENTCOUNT, currentCount);
             header.addStringValue("time", Long.toString(endTime - startTime));
-            header.addIntegerValue(OUT_FIRST_ENTRY_ON_PAGE, firstNum);
-            header.addIntegerValue(OUT_LAST_ENTRY_ON_PAGE, curNum);
+            header.addBigIntegerValue(OUT_FIRST_ENTRY_ON_PAGE, firstNum, 10);
+            header.addBigIntegerValue(OUT_LAST_ENTRY_ON_PAGE, curNum, 10);
 
         } catch (EBaseException e) {
             header.addStringValue(OUT_ERROR, e.toString(locale));
         } catch (Exception e) {
         }
         return argset;
-
     }
 
     /**
@@ -485,10 +495,10 @@ public class QueryReq extends CMSServlet {
      */
     private void trim(Vector v, RequestId marker) {
         int i = v.size() - 1;
-        if (((IRequest) v.elementAt(i)).getRequestId().equals(marker)) {
+        if (((IRequest) v.elementAt(i)).getRequestId().toString().equals(
+                marker.toString())) {
             v.remove(i);
         }
-
     }
 
     /**
@@ -525,12 +535,12 @@ public class QueryReq extends CMSServlet {
      */
     private Vector normalizeOrder(Vector list) {
 
-        int firstrequestnum = Integer.parseInt(((IRequest) list.elementAt(0))
+        BigInteger firstrequestnum = new BigInteger(((IRequest) list.elementAt(0))
                 .getRequestId().toString());
-        int lastrequestnum = Integer.parseInt(((IRequest) list.elementAt(list
+        BigInteger lastrequestnum = new BigInteger(((IRequest) list.elementAt(list
                 .size() - 1)).getRequestId().toString());
         boolean reverse = false;
-        if (firstrequestnum > lastrequestnum) {
+        if (firstrequestnum.compareTo(lastrequestnum) > 0) {
             reverse = true; // if the order is backwards, place items at the beginning
         }
         Vector v = new Vector();
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/ReqParser.java b/pki/base/common/src/com/netscape/cms/servlet/request/ReqParser.java
index 00f95ec2dddc2aa28a307d0e8c37aaf9ccb9e145..230ddb43382997b151e979408dbedeb48a9a81bd 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/ReqParser.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/ReqParser.java
@@ -18,6 +18,7 @@
 package com.netscape.cms.servlet.request;
 
 import java.util.Locale;
+import java.math.BigInteger;
 
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.base.IArgBlock;
@@ -51,8 +52,8 @@ public class ReqParser implements IReqParser {
     public void fillRequestIntoArg(Locale l, IRequest req, CMSTemplateParams argSet, IArgBlock arg)
             throws EBaseException {
         arg.addStringValue(TYPE, req.getRequestType());
-        arg.addLongValue("seqNum",
-                Long.parseLong(req.getRequestId().toString()));
+        arg.addBigIntegerValue("seqNum",
+                new BigInteger(req.getRequestId().toString()), 10);
         arg.addStringValue(STATUS,
                 req.getRequestStatus().toString());
         arg.addLongValue(CREATE_ON,
-- 
1.7.7.5

